module.exports = {
	reportDomEvent : function(uri, headers, data, onSuccess, onError) {
		var dataType = "formUrl";

		if(this.normalizedTypeName(data) === "Uint8Array") {
			// cordova will treat a normal Uint8Array as an object of property (index position in array) and value is the actual value in the array (double the actual size)
			// So we must change data type to ArrayBuffer as cordova has a special handling for this type which change it to base64.
      		data = data.buffer;
      		dataType = "gzip";
		}

		var args = [uri, headers, data, dataType];
		cordova.exec(onSuccess, onError, "GlassboxPlugin", "domReport", args);
	},

	setSessionCookie : function(cookie, onSuccess, onError) {
		var args = [cookie];
		cordova.exec(onSuccess, onError, "GlassboxPlugin", "setSessionCookie", args);	
	},

	startSession: function(onSuccess, onError) {
		if(typeof _detector !== 'undefined') {
			var clss = _detector.sessionId();
        	var clsv = _detector.visitorId();
        	var cookie = clss ? "_cls_s" + "=" + clss + ";" : "";
        	if(clsv) {
            	cookie = cookie + "_cls_v" + "=" + clsv;
        	}

        	this.onBridgeReady(cookie, onSuccess, onError);
		} else {
			console.warn("Detector undefined. skipping session start");
		}
	},

	reportEvent: function(event, params, onSuccess, onError) {
		var args = [event, params || {}];
		cordova.exec(onSuccess, onError, "GlassboxPlugin", "reportEvent", args);		
	},
	/**
      For internal usage
	**/
	onBridgeReady: function(clsCookies, onSuccess, onError) {
		var args = [clsCookies];
		cordova.exec(onSuccess, onError, "GlassboxPlugin", "onBridgeReady", args);	
	},

	startScreen: function(screenName, onSuccess, onError) {
		var args = [screenName];
		cordova.exec(onSuccess, onError, "GlassboxPlugin", "startScreen", args);	
	},

    // copied from cordova.exec. this method returns an actual type and not just 'object' for object such as Uint8Array or other array buffers.
	normalizedTypeName : function(val) {
		return Object.prototype.toString.call(val).slice(8, -1);
	}
};
