
/// <reference path="../node_modules/tns-platform-declarations/ios.d.ts" />

declare class Storyboard extends NSObject {
	static alloc(): Storyboard;
	static new(): Storyboard;

	static start(): boolean;
	static startAppIdError(reportUrl: string, appId: string, error: any): boolean;
	static startError(settings: GLAStartupSettings, error:any): boolean;
	static stop(): void;
	public static startScreen(screenName: string): void;
	public static endScreen(): void;
	public static reportEventParameters(eventName: string, parameters: NSDictionary): void;
	public static hideSensitiveView(view: UIView): void;
}

declare class GLAStartupSettings extends NSObject {
	static alloc(): GLAStartupSettings;

	static new(): GLAStartupSettings; 

	static settings(): GLAStartupSettings;

	reportUrl: string;

	appId: string;

	certificate: NSData;

	configuraiton: GLAConfigurationType;
}

declare const enum GLAConfigurationType {
	GLAConfigurationExternal = 0,

	GLAConfigurationInternal = 1
}